# Interface methods for submodule: GradientDescentOptimizer
from typing import Union, Any
# additional imports
from .support.template_class import itkTemplate as _itkTemplate
from ._proxies import SingleValuedNonLinearOptimizerProxy as _SingleValuedNonLinearOptimizerProxy


# Interface methods for class: GradientDescentOptimizer
class GradientDescentOptimizerProxy(_SingleValuedNonLinearOptimizerProxy):
	@staticmethod
	def New():
		""""""
		...

	def Clone(self):
		""""""
		...

	def GetNameOfClass(self):
		""""""
		...

	def GetMaximize(self) -> bool:
		""""""
		...

	def SetMaximize(self, _arg: bool) -> None:
		""""""
		...

	def MaximizeOn(self) -> None:
		""""""
		...

	def MaximizeOff(self) -> None:
		""""""
		...

	def GetMinimize(self) -> bool:
		""""""
		...

	def SetMinimize(self, v: bool) -> None:
		""""""
		...

	def MinimizeOn(self) -> None:
		""""""
		...

	def MinimizeOff(self) -> None:
		""""""
		...

	def AdvanceOneStep(self) -> None:
		""""""
		...

	def StartOptimization(self) -> None:
		""""""
		...

	def ResumeOptimization(self) -> None:
		""""""
		...

	def StopOptimization(self) -> None:
		""""""
		...

	def SetLearningRate(self, _arg: float) -> None:
		""""""
		...

	def GetLearningRate(self) -> float:
		""""""
		...

	def SetNumberOfIterations(self, _arg: int) -> None:
		""""""
		...

	def GetNumberOfIterations(self) -> int:
		""""""
		...

	def GetCurrentIteration(self) -> int:
		""""""
		...

	def GetValue(self) -> float:
		""""""
		...

	def GetStopCondition(self):
		""""""
		...

	def GetStopConditionDescription(self) -> str:
		""""""
		...

	def GetGradient(self) -> Sequence[float]:
		""""""
		...

